package jini;

import java.io.*;
import java.net.*;
import java.rmi.*;
import java.rmi.server.*;

public class LookupLocator 
{

 	private static boolean weAreDebugging = true;
	private static void debug( String text )
	{
			if (weAreDebugging)
					System.out.println( text );
	}

	private String location;

  public LookupLocator( String location ) 
  {
    System.out.println( "Created a new LookupLocator");
    this.location = location;
  }

	public ServiceRegistrar oldgetRegistrar()
  {
    System.out.println( "LookupLocator is getting a registrar...");
		
		try {
				URL [] codebase = new URL [1];
				//codebase[0] = new URL( "file://localhost/D:/jinifilter_project/" );	 
				codebase[0] = new URL( "http://csroam31.stanford.edu:10005/" );	 
				Class cl = java.rmi.server.RMIClassLoader.loadClass( codebase[0], "lalaland.ServiceRegistrarImpl" );
				debug("class " + cl + " was loaded successfully by " + cl.getClassLoader() );
				ServiceRegistrar sr = (ServiceRegistrar) cl.newInstance();
				return sr; 
				
    } catch (Exception e) {
				e.printStackTrace( System.out );
        return null;
    }
  }


	public ServiceRegistrar getRegistrar()
  {
    System.out.println( "LookupLocator is getting a registrar...");
		
		try {
				URL codebase = new URL( "http://localhost:10005/lalaland.ServiceRegistrarImpl.object" );

				ObjectInputStream inobj = new ObjectInputStream( codebase.openStream() );
				MarshalledObject mars = (MarshalledObject) inobj.readObject();

				Object obj = mars.get();
				debug( obj + " was loaded successfully by " + obj.getClass().getClassLoader() );
				return (ServiceRegistrar) obj;
				
    } catch (Exception e) {
				e.printStackTrace( System.out );
        return null;
    }
  }

}
